3 Sum (LeetCode 15) | Full solution with examples and visuals | Interview Essential

แชร์
ฝัง
  • เผยแพร่เมื่อ 1 ต.ค. 2024

ความคิดเห็น • 120

  • @ngm-oe8ow
    @ngm-oe8ow ปีที่แล้ว +29

    If you sort the array the complexity becomes O(nLog(n)) in the 2 sum part and you said the complexity becomes o(n), but for the 3sum sorting is okay because you are reducing it to o(n^2). The explanation was quite good and understandable thanks.

    • @peasantfaye5403
      @peasantfaye5403 ปีที่แล้ว

      It's not like you sort an array n times in sum2, however. You sort an array once, then you iterate through it in O(n) time. You could say it's O(n + log(n)), but it's still linear time, so we simplify it to O(n).

    • @ngm-oe8ow
      @ngm-oe8ow ปีที่แล้ว +9

      With the inbuilt sorting or any sorting algorithm it would take O(nlog(n)) not O(log(n)) time. so O(nlog(n)+n)) simplifies to O(nlog(n)). so it's not linear time. it would take linear time if you use hashing.

    • @peasantfaye5403
      @peasantfaye5403 ปีที่แล้ว

      True, my bad.@@ngm-oe8ow

    • @bobaGogo
      @bobaGogo ปีที่แล้ว +4

      @@peasantfaye5403 you can only solve 2 sum in O(n) with a hashmap. If you do the 2 pointer solution you will get a O(1) space complexity, but O(n*log(n)) time complexity.

    • @GaganSingh-zz9el
      @GaganSingh-zz9el 8 หลายเดือนก่อน

      why nlogn time complexity in 2sum using 2 pointer
      @@bobaGogo

  • @anoopghildiyal6413
    @anoopghildiyal6413 4 หลายเดือนก่อน +9

    At 5:30 how the time complexity is O(n)?? you have sorted the array so it would be O(nlogn) already for the sorting so how it would be O(n) for total algorithm??

    • @SRC_ARENA
      @SRC_ARENA หลายเดือนก่อน +1

      Using a HashMap, the complexity for TwoSum will be O(N). Without sorting only it can be done.

    • @AyushSharma-vq5ix
      @AyushSharma-vq5ix 3 วันที่ผ่านมา

      i think the same thing, TC should be O(nlogn) + O(n) , SC= O(n)

  • @butteredtequilla9046
    @butteredtequilla9046 ปีที่แล้ว +22

    You have just gained a subscriber. Out of all videos, this is so far the most comprehensible explanation. Thank you kind sir!!

    • @nikoo28
      @nikoo28  ปีที่แล้ว +1

      Welcome aboard! Your feedback and love is much appreciated. Keeps me motivated :D

    • @ZachDift-kc4nk
      @ZachDift-kc4nk 3 หลายเดือนก่อน +1

      did this code work when you submitted it on leetcode?

    • @butteredtequilla9046
      @butteredtequilla9046 3 หลายเดือนก่อน

      @@ZachDift-kc4nk I can’t remember honestly it was a long time ago

  • @rawatbrothers0yt968
    @rawatbrothers0yt968 7 หลายเดือนก่อน +2

    why are you looking like young Narendra Modi

  • @MadhavanMan
    @MadhavanMan ปีที่แล้ว +3

    The code takes 672 Runtime.Whether it is optimal

  • @yadavom2001
    @yadavom2001 7 วันที่ผ่านมา +1

    Beautifully explained 😊

  • @GouravKumar-r2p
    @GouravKumar-r2p ปีที่แล้ว +2

    Nikhil We want 4sum leetcode solution.

  • @imdarkseid2343
    @imdarkseid2343 2 หลายเดือนก่อน +1

    you did well soldier,nice approach simple and elegant but the duplicates numbers in arrays has to skipped to increase the faster execution

  • @thegaur-b4s
    @thegaur-b4s 18 วันที่ผ่านมา

    This is a good solution but the use of Set and then copying it back into a list is increasing the time complexity further, you fail to take that into account, on leetcode this solution takes more than 800ms which will not be good enough to clear the interview where they are expecting the optimal solution. Maybe you should also post how well your solutions perform compared to others on leetcode.

  • @checkraiser100
    @checkraiser100 4 หลายเดือนก่อน +1

    Damn, this video made the problem super easy

  • @architagarwal7379
    @architagarwal7379 6 หลายเดือนก่อน +2

    Time complexity is O[n^2logn]. We have to use hashmap apprach of 2 sum if the array is not sorted by default

    • @nikoo28
      @nikoo28  5 หลายเดือนก่อน +1

      O(n^2) will be dominant

    • @NIGHTSHADE123
      @NIGHTSHADE123 หลายเดือนก่อน

      @@nikoo28 we are sorting the array so complexity should be 0(n2 logn)

  • @ShantanuSaha-vo6zh
    @ShantanuSaha-vo6zh 28 วันที่ผ่านมา

    Notice that the solution set must not contain duplicate triplets. Your solution will return duplicate triplets. For example: [-2,0,0,2,2]

    • @nikoo28
      @nikoo28  26 วันที่ผ่านมา

      we do handle duplicates. What output did you get with this test case?

  • @rishikakoul6336
    @rishikakoul6336 6 หลายเดือนก่อน +1

    CAN ANYONE EXPLAIN ME WHY HE DID ELSEIF(SUM

    • @sumitkaranjkar3819
      @sumitkaranjkar3819 หลายเดือนก่อน

      as he explained we need to adjust the index as per the sum
      ex- if sum

  • @RakshithVrishab-ht8vk
    @RakshithVrishab-ht8vk ปีที่แล้ว +3

    Simple ,yet optimized , thanks Nikhil!

  • @VIJAYMAMORIA-c8m
    @VIJAYMAMORIA-c8m 4 หลายเดือนก่อน

    Bro, Your solution is wrong where you are assuming that HashSet will remove duplicate Lists.
    {1,2,3} & {3,2,1} are two different lists. They wont be considered duplicate by the HashSet as List equals method wont return equal for both.
    Set result = new HashSet();
    result.add(Arrays.asList(1, 2, 3));
    result.add(Arrays.asList(3, 2, 1));
    System.out.println(result.size()); // Prints 2 NOT 1

    • @nikoo28
      @nikoo28  4 หลายเดือนก่อน

      That is why I sort the array. :)

    • @VIJAYMAMORIA-c8m
      @VIJAYMAMORIA-c8m 4 หลายเดือนก่อน +1

      @@nikoo28 Ok. got it. Since always the sorted List is added to the Set duplicate list addition is taken care of by the Set. But we can optimize the solution to avoid trying to add even those duplicate lists.
      int twoSum = A[left] + A[right];
      if (twoSum == sum) {
      triplets.add(Arrays.asList(A[i], A[left], A[right]));
      /**
      * Only if we have found a solution for two values we can be sure we should move ahead of all their
      * duplicates.
      */
      while (left < right && A[left + 1] == A[left]) {
      ++left;
      }
      ++left;
      while (left < right && A[right - 1] == A[right]) {
      --right;
      }
      --right;
      }

  • @sumitkaranjkar3819
    @sumitkaranjkar3819 หลายเดือนก่อน

    what about edge cases
    like all +ve or all -ve or all 0
    where you have to return {}, {}, {0,0,0} respectively

  • @kchemutai3483
    @kchemutai3483 3 หลายเดือนก่อน

    Great explanation, I just wanted a clarification on the time complexity, i think we left out the time complexity for sorting. What is the time complexity for sorting, otherwise the rest is O(n^2) as explained.

  • @shrutisrivastava5530
    @shrutisrivastava5530 4 หลายเดือนก่อน

    The solution was very simple to understand thankyou so much.
    But i had a doubt as I implemented this on leetcode, the time it took for all the test cases was: 457ms , and 9ms solutions were also available. So I have to study the more optimum approach or it is fine for technical round or interview round?

  • @hajarelalit
    @hajarelalit 8 หลายเดือนก่อน

    Nice solution, I have now subscribed to your channel, very good explanation and solution. I want to clear Toptal interview, please guide me in some way if possible. Thanks !

  • @jataman123
    @jataman123 7 หลายเดือนก่อน +1

    How does this solution ensures that we don't use one value multiple times?

    • @nikoo28
      @nikoo28  6 หลายเดือนก่อน

      because all 3 pointers point at different indexes

  • @architagarwal7379
    @architagarwal7379 6 หลายเดือนก่อน

    Nice explanation but there are 2 cases over here. if the array is sorted already or the array is not sorted. if the array is sorted we can go with the approach explained by nukhil but if its not sorted the better use hashmap approach which gives O[n] TC and O[N] SC

  • @ShahidHussain-dh3pg
    @ShahidHussain-dh3pg 22 วันที่ผ่านมา

    Amazing explanation. You redefined the meaning of comprehensive😎

  • @Satya-g5t
    @Satya-g5t 23 วันที่ผ่านมา

    Really appreciate the effort you put into making other people understand. It is great service.

  • @vamshigud151
    @vamshigud151 3 หลายเดือนก่อน

    stock market bear bank side

  • @michaeljohnbritto8399
    @michaeljohnbritto8399 หลายเดือนก่อน

    thanks for your fantastic explaination with simple code.

  • @omkar._.k
    @omkar._.k 8 หลายเดือนก่อน +1

    Perfect

  • @SamSafi003
    @SamSafi003 8 หลายเดือนก่อน +1

    Thank you ... ❤

  • @mikedelta658
    @mikedelta658 9 หลายเดือนก่อน +1

    Thank you

  • @rupeshpatil6957
    @rupeshpatil6957 15 วันที่ผ่านมา

    Thanks Brother

  • @AzharKhan-e9m
    @AzharKhan-e9m 3 หลายเดือนก่อน

    isme ek problem hai duplicate triplets ko lekr ... triplets double print horhe

  • @anurag_dutt
    @anurag_dutt 7 หลายเดือนก่อน

    Bhaiya, the explanation is so good but we have to skip the duplicate triplets. So, we have to do this
    If (i>0 && nums[i]==nums[i-1]){
    Continue;
    }
    Duplicate triplets are the question [-4,-1,-1,0,1,2] are
    See the [-1(1 idx),0,1] and [-1(2 idx),0,1]..
    Thank you.❤

    • @Prm906
      @Prm906 6 หลายเดือนก่อน +1

      to skip duplicates thats why he uses hashset

  • @hinocenciopaulo
    @hinocenciopaulo 4 หลายเดือนก่อน +1

    Best approach.

  • @venkateshdhanasekaran5398
    @venkateshdhanasekaran5398 2 หลายเดือนก่อน

    After seeing lot many videos, finally I found the crystal clear approach.. Thank you so much brother. One question, how you handle the duplicate element in this?

    • @nikoo28
      @nikoo28  2 หลายเดือนก่อน

      I am using a HashSet, that takes care of duplicates

  • @mayankkumargiri1289
    @mayankkumargiri1289 3 หลายเดือนก่อน

    13:06 If you're not taking any extra space at all, the space complexity should be O(1)

    • @nikoo28
      @nikoo28  3 หลายเดือนก่อน

      i misspoke, you are taking the space of the HashSet which has a size (n). Hence O(n).
      Thanks for the correction.

  • @AteebTahir-z1i
    @AteebTahir-z1i 2 หลายเดือนก่อน

    but how to handl eduplicates

    • @nikoo28
      @nikoo28  2 หลายเดือนก่อน

      that is why a hashset is used

  • @mrepic2797
    @mrepic2797 หลายเดือนก่อน

    thnks

  • @oknokok
    @oknokok 2 หลายเดือนก่อน

    Nice explanation, setup and video quality 📸

  • @ZachDift-kc4nk
    @ZachDift-kc4nk 3 หลายเดือนก่อน

    does this solution actually work in leetcode? i am getting an error when i submit (not run) the code.

    • @nikoo28
      @nikoo28  3 หลายเดือนก่อน

      yes it does, check out the complete implementation on the Github link available in video description

  • @meriyemelhajoui4083
    @meriyemelhajoui4083 10 หลายเดือนก่อน

    I dont see what we should sort the array ? if we gonna loop over the loop and everytime fix and try to found a sum that s equal to 0

    • @nikoo28
      @nikoo28  9 หลายเดือนก่อน

      Sorting the array ensures that all smaller numbers are to the left abd larger to the right.
      Then you look at the sum obtained…if greater than target, then you need to pick a smaller number..so just move the right pointer by 1 place instead of traversing the entire array.
      Saves you a lot of time.

  • @harshitha5929
    @harshitha5929 ปีที่แล้ว

    Good evening sir
    Thank you for such a keen explanation. Sir can you do leetcode problems on python 😊

  • @Mano_Vikas
    @Mano_Vikas 9 หลายเดือนก่อน

    You said, for viola in between at 5:22. What does that mean? Just curious

    • @nikoo28
      @nikoo28  9 หลายเดือนก่อน

      Means kind of ‘wow’ as an exclamation

  • @sysybaba420
    @sysybaba420 ปีที่แล้ว

    you are using a set to arrive at a solution right? so how do you say that you are not using any extra space? or is it just constant space?

    • @nikoo28
      @nikoo28  11 หลายเดือนก่อน

      it is constant space.

  • @karthikmalode-ir5tw
    @karthikmalode-ir5tw 2 หลายเดือนก่อน

    Great solution ..understandable

  • @shabanafirdose4671
    @shabanafirdose4671 ปีที่แล้ว +1

    Too good , Thank you for sharing your knowledge

    • @nikoo28
      @nikoo28  ปีที่แล้ว

      glad i could help you!!

  • @plutomessi21
    @plutomessi21 ปีที่แล้ว

    thank you bhaiya , i was stuck in this since yesterday

  • @NeelakshiSachdeva
    @NeelakshiSachdeva 3 หลายเดือนก่อน +2

    Girl did 2 sum and 3 sum today!! Keep going, faang is waiting for me

    • @nikoo28
      @nikoo28  3 หลายเดือนก่อน +1

      You can do it!

  • @vinaypratapsingh339
    @vinaypratapsingh339 5 หลายเดือนก่อน

    if you sort the array, you will lost the indices.

    • @pradeepphulse4876
      @pradeepphulse4876 3 หลายเดือนก่อน +1

      But you need to return the values. Not the indexes.

  • @user-qy2fm3pu2b
    @user-qy2fm3pu2b 2 หลายเดือนก่อน

    great man

  • @Dadu-g4r
    @Dadu-g4r ปีที่แล้ว +1

    Amazing explanation 🔥

    • @nikoo28
      @nikoo28  ปีที่แล้ว

      Thank you 🙌 😄

  • @supershinobi7892
    @supershinobi7892 ปีที่แล้ว

    your explanation is awesome thank you brother i was not able to solve this question before your video Now i solved.

    • @nikoo28
      @nikoo28  ปีที่แล้ว

      You are most welcome

  • @gireeswar18
    @gireeswar18 3 หลายเดือนก่อน

    Perfect Video !!!

  • @rukhsanakhan9542
    @rukhsanakhan9542 3 หลายเดือนก่อน

    dil se pyaar aapko sir

  • @asr.explores
    @asr.explores 10 หลายเดือนก่อน

    well explained

  • @samridhshubham8109
    @samridhshubham8109 ปีที่แล้ว

    Very Excellent solution, was stuck in this prob for hrs

    • @nikoo28
      @nikoo28  11 หลายเดือนก่อน

      glad I could help

  • @hoddybhaba6704
    @hoddybhaba6704 ปีที่แล้ว

    Easy to understand!!!

  • @sandeepkashyap7239
    @sandeepkashyap7239 ปีที่แล้ว

    great
    great explanation

  • @parthbhayana6326
    @parthbhayana6326 8 หลายเดือนก่อน

    Jo bhi bolo Hairfall toh bhot hogya 2 saalo me. 😂

    • @nikoo28
      @nikoo28  7 หลายเดือนก่อน

      can't escaping aging 😅

  • @melk48111
    @melk48111 11 หลายเดือนก่อน

    Great work Nikhil

  • @NeerajManoj
    @NeerajManoj ปีที่แล้ว

    nice bro

  • @purnimahianl5678
    @purnimahianl5678 ปีที่แล้ว

    You explain very well 👏

  • @rgowtham9445
    @rgowtham9445 ปีที่แล้ว

    good 🤩

  • @ghayoorhussain8930
    @ghayoorhussain8930 ปีที่แล้ว

    Crystal Clear Explanation Sir

  • @AbhishekKumar-hi8oj
    @AbhishekKumar-hi8oj ปีที่แล้ว

    very nice explanation, before that i went through couple of video to understand properly but this time I understood . Thanks.

    • @nikoo28
      @nikoo28  ปีที่แล้ว

      glad I could help

  • @sysybaba420
    @sysybaba420 ปีที่แล้ว

    great explanation, congratulations on putting in this effort!!!

    • @nikoo28
      @nikoo28  11 หลายเดือนก่อน

      Glad you enjoyed it!

  • @jayprakashjaiswal8220
    @jayprakashjaiswal8220 ปีที่แล้ว

    Bro please bring more video on trees and graph

    • @nikoo28
      @nikoo28  ปีที่แล้ว +1

      i am adding more and more videos every week. I am myself limited by resources and time. Hope you understand...if you have a particular topic/question in mind, let me know..and I can add it to my video list.

    • @MadhavanMan
      @MadhavanMan ปีที่แล้ว

      @@nikoo28 Complete binary search problem series

    • @nikoo28
      @nikoo28  7 หลายเดือนก่อน

      The complete playlist on graphs is now available: th-cam.com/play/PLFdAYMIVJQHNFJQt2eWA9Sx3R5eF32WPn.html

  • @SuriyaT3001
    @SuriyaT3001 ปีที่แล้ว

    This is not right .. pls check it out it gives duplicate output but in question they asked only unique subsets.. while dry run of your code pls execute in leet code itself ..

    • @nikoo28
      @nikoo28  ปีที่แล้ว

      check the code available on github in description. It does pass on leetcode.

    • @ngm-oe8ow
      @ngm-oe8ow ปีที่แล้ว

      he is storing it in a HashSet so it won't have duplicates.

    • @BharathVasudevan-s9u
      @BharathVasudevan-s9u 6 หลายเดือนก่อน

      Your videos are awesome, thanks for all the details. Can we avoid having the duplicates, like adding memorization? Is that possible?

    • @VIJAYMAMORIA-c8m
      @VIJAYMAMORIA-c8m 4 หลายเดือนก่อน

      You are correct. His solution is wrong. it wont remove duplicates.

  • @kshitijpandey9376
    @kshitijpandey9376 9 หลายเดือนก่อน

    Understood the solution very well. Thank you

  • @joydeep_
    @joydeep_ 3 หลายเดือนก่อน

    Sorry to say, but not the best approach.

    • @nikoo28
      @nikoo28  3 หลายเดือนก่อน

      what would you suggest?

  • @TuringTested01
    @TuringTested01 ปีที่แล้ว

    I think one more optimization you can do is this:
    Keeping a boolean array of "done" numbers and marking the numbers with which triplets are already made, because there could be duplicates of each number and for each of them you dont have to find the triplets because triplets would be unique,
    for example: if there is an array of 3000 integers all containing zero, your code would go to every zero and find the triplets using all zeros whereas the answer would just be [0,0,0]

    • @gauratomar
      @gauratomar ปีที่แล้ว +1

      In this way some cases would be lost as -1, 0,1 and 2,-1, -1 are also there both use -1 and both are different trplets

  • @ibrahim-abdallatif
    @ibrahim-abdallatif 8 หลายเดือนก่อน

    Thanks for the clear explanation, but please note that this solution allows duplicate triplets in the result, which is not correct and won't pass leetcode submission (I tried it myself), here is the correct solution after some changes:
    >>> EDIT: When I tried it I was using a LinkedList instead of a HashSet as shown in the video(using HashSet won't allow duplicates indeed and hence the presented solution is correct), anyway here is the correct way to solve it with LinkedList.
    class Solution {
    public List threeSum(int[] nums) {
    Arrays.sort(nums);
    List result = new LinkedList();
    for (int i = 0; i < nums.length -2; i++) {
    if(i == 0 || (i > 0 && nums[i] != nums[i-1])) {
    int left = i + 1;
    int right = nums.length - 1;
    while(left < right) {
    int sum = nums[i] + nums[left] + nums[right];
    if (sum == 0) {
    result.add(Arrays.asList(nums[i], nums[left], nums[right]));
    while(left < right && nums[left+1] == nums[left]) left++;
    while(left < right && nums[right-1] == nums[right]) right--;
    left++;
    right--;
    } else if(sum < 0) {
    left++;
    } else {
    right--;
    }
    }
    }
    }
    return result;
    }
    } // TC: O(n^2), SC: O(n)

    • @nikoo28
      @nikoo28  7 หลายเดือนก่อน

      the solution I provided on my github profile does pass leetcode.

    • @satyaganesh7159
      @satyaganesh7159 7 หลายเดือนก่อน

      Set uses equals and hashcode to compare elements in it, so list1.equals(list2) compares each element sequentially

  • @theexplorerayesha
    @theexplorerayesha หลายเดือนก่อน

    The best and simplest explanation and code I found on TH-cam 🥹 thank you so much sir